unit Vraag2UMEMO;
  {*** Oplossing vir Vraag 2. ***}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Menus,
  uVr2Memo;

type
  TfrmV2 = class(TForm)
    mnuMain: TMainMenu;
    mnuOpsieA: TMenuItem;
    mnuVerlaat: TMenuItem;
    redV2: TRichEdit;
    procedure mnuVerlaatClick(Sender: TObject);
    procedure mnuOpsieAClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmV2: TfrmV2;
  arrToere : Array[1..50] of TData;
  iAantal  : Integer = 0;

implementation

{$R *.dfm}
{$R+}

procedure TfrmV2.FormCreate(Sender: TObject);
var
   TLeer               : TextFile;
   sReelA, sReelB      : String;
   sGNaam, sDNaam, sMnd, sAantD, sAantT : String;
begin
   {Kode vir OnCreate-event van vorm}
   randomize;
   IF NOT FileExists('DataV2.txt')
    then
     begin
       MessageDlg('FOUT: Leer bestaan nie.', mtError, [mbOk], 0);
       mnuOpsieA.Enabled := False;
       Exit;
     end;

   AssignFile(TLeer, 'DataV2.txt');
   Reset(TLeer);
   While NOT EOF(TLeer) DO
    Begin
      Readln(TLeer, sReelA);
      Readln(TLeer, sReelB);

      sGNaam := copy(sReelA, 1, pos('&', sReelA)-1);
      sDNaam := copy(sReelA, pos('&', sReelA)+1, length(sReelA));

      sMnd  := copy(sReelB, 1, pos(' vir ', sReelB) -1);
      Delete(sReelB, 1, pos('vir', sReelB)+3); //verwyder ook spasie na "vir "
      sAantD  := copy(sReelB, 1, pos(' ', sReelB)-1);
      Delete(sReelB, 1, pos('#', sReelB));
      sAantT  := sReelB;

      Inc(iAantal, 1);
      arrToere[iAantal] := TData.Create(sGNaam, sDNaam, sMnd, StrtoInt(sAantD), StrToInt(sAantT));
    End; //while
   CloseFile(TLeer);
end;

procedure TfrmV2.mnuOpsieAClick(Sender: TObject);
var
   sMnd, sGeluk                          : String;
   a, iTNom                              : Integer;
   rNTarief                              : Real;
   cLKarak                               : Char;
begin
  {Kode Opsie A}
  sMnd := INPUTBOX('Vraag 2', 'Sleutel die maand van die toer in bv. Februarie?', 'Februarie');
  redV2.Lines.Clear;
  redV2.Paragraph.TabCount := 1;
  redV2.Paragraph.Tab[0]   := 100;
  redV2.Lines.Add('Toere vir die maand ' + sMnd);
  redV2.Lines.Add('=========================');
  redV2.Lines.Add('Nommer' + #9 + 'Bestemming');
  for a := 1 to iAantal do
   begin
     if Uppercase(arrToere[a].getMNaam) = Uppercase(sMnd)
      then redV2.Lines.Add(intToStr(a) + #9 + arrToere[a].getDNaam);
   end;

  iTNom := StrToInt(InputBox('Vraag 2', 'Sleutel die toernommer uit die lys in, bv. 35', '35'));
  redV2.Lines.Add('');
  redV2.Lines.Add(arrToere[iTNom].toString);

  redV2.Lines.Add(' ');
  sGeluk := InputBox('Vraag 2', 'Sleutel enige karakter in uit '+
            arrToere[iTNom].getDNaam +'.', '');
  cLKarak := arrToere[iTNom].vindGelukKarak;
  IF Upcase(cLKarak) = UpCase(sGeluk[1])
   then
    begin
      rNTarief := arrToere[iTNom].getTarief * 0.75; //25% discount
      redV2.Lines.Add('Baie geluk! Jy ontvang 25% afslag op die daaglikse tarief! '+ #13 +
                      'Die daaglikse tarief was ' +
          FloatToStrF(arrToere[iTNom].getTarief, ffCurrency, 8,2) +
                      '. Dit is verlaag na ' +
          FloattoStrF(rNTarief, ffCurrency, 8, 2) + ' per dag.');
    end
   else
    begin
      redV2.Lines.Add('Die gelukkige karakter was die letter '+ cLKarak+'.' + #13 +
                      'Geen afslag. Die tarief is steeds ' +
          FloatToStrF(arrToere[iTNom].getTarief, ffCurrency, 8,2) + ' per dag.');
    end;
end;

procedure TfrmV2.mnuVerlaatClick(Sender: TObject);
begin
  Application.Terminate;
end;

end.
