unit Vraag1UMemo;
   //oplossing vir Vraag 1  ...
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, ADODB, Grids, DBGrids, ExtCtrls, Buttons, Menus;

type
  TfrmVraagEEN = class(TForm)
    qryRec: TADOQuery;
    dsrQry: TDataSource;
    grdRec: TDBGrid;
    mnuMain: TMainMenu;
    mnuOpsieA: TMenuItem;
    mnuOpsieB: TMenuItem;
    mnuOpsieC: TMenuItem;
    mnuOpsieD: TMenuItem;
    mnuOpsieE: TMenuItem;
    mnuOpsieF: TMenuItem;
    mnuOpsieG: TMenuItem;
    mnuVerlaat: TMenuItem;
    procedure mnuOpsieAClick(Sender: TObject);
    procedure mnuOpsieBClick(Sender: TObject);
    procedure mnuOpsieCClick(Sender: TObject);
    procedure mnuOpsieDClick(Sender: TObject);
    procedure mnuOpsieEClick(Sender: TObject);
    procedure mnuOpsieFClick(Sender: TObject);
    procedure mnuOpsieGClick(Sender: TObject);
    procedure mnuVerlaatClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmVraagEEN: TfrmVraagEEN;

implementation

{$R *.dfm}

procedure TfrmVraagEEN.mnuOpsieAClick(Sender: TObject);
begin
  qryRec.Close;
  qryRec.SQL.Text :=  'SELECT * FROM tblToere ORDER BY Bestemming, BeginDatum Desc';
  qryRec.Open;
end;

procedure TfrmVraagEEN.mnuOpsieBClick(Sender: TObject);
begin
  qryRec.Close;
  qryRec.SQL.Text :=  'SELECT ToerID, Voornaam, Van ' +
                      'FROM tblToeriste ' +
                      'WHERE Van LIKE "C%" AND Voornaam LIKE "C%" AND ' +
                      'Geslag = "V"';
  qryRec.Open;
end;

procedure TfrmVraagEEN.mnuOpsieCClick(Sender: TObject);
var
   sX : String;
begin
  sX := INPUTBOX('Vraag 1', 'Land van herkoms bv. Spanje?', 'Spanje');
  qryRec.Close;
  qryRec.SQL.Text :=  'SELECT ToerID, Van FROM tblToeriste '+
                      'WHERE (Deposito = TRUE) AND ' +
                      '(Land = "' + sX + '")';;
  qryRec.Open;
end;

procedure TfrmVraagEEN.mnuOpsieDClick(Sender: TObject);
begin
  qryRec.Close;
  qryRec.SQL.Text :=  'SELECT Van, BeginDatum, EindDatum, ' +
                      '(EindDatum-BeginDatum)+1 AS AantalDae ' +
                      'FROM tblToere '+
                      'WHERE (BeginDatum >= #2012/06/12#) AND ' +
                      '      (EindDatum <= #2012/10/31#) AND ' +
                      '      ((EindDatum-BeginDatum) + 1 > 5) ';
  qryRec.Open;
end;

procedure TfrmVraagEEN.mnuOpsieEClick(Sender: TObject);
begin
  qryRec.Close;
  qryRec.SQL.Text :=  'DELETE FROM tblToere WHERE Year(EindDatum) = 2011';
  qryRec.ExecSQL;
  MessageDlg('Rekords suksesvol verwerk',mtInformation,[mbok],0);
end;

procedure TfrmVraagEEN.mnuOpsieFClick(Sender: TObject);
begin
  qryRec.Close;
  qryRec.SQL.Text :=  'SELECT Land, ' +
                      'Format(Sum(BedragBetaal),"Currency") AS InkomstePerLand ' +
                      'FROM tblToeriste ' +
                      'GROUP BY Land';
  qryRec.Open;
end;

procedure TfrmVraagEEN.mnuOpsieGClick(Sender: TObject);
begin
  qryRec.Close;
  qryRec.SQL.Text :=  'SELECT Bestemming, BeginDatum , Sitplekke, ' +
                      ' Count(V.Van) AS [PlekkeBespreek]' +
                      'FROM tblToere T, tblToeriste V ' +
                      'WHERE T.ToerID = V.ToerID ' +
                      'GROUP BY Bestemming, BeginDatum , Sitplekke ' +
                      'HAVING Count(V.Van) < T.Sitplekke';;
  qryRec.Open;
end;

procedure TfrmVraagEEN.mnuVerlaatClick(Sender: TObject);
begin
   Application.Terminate;
end;

end.
