unit Vraag3UMemo;

{*** 'n Oplossing vir Vraag 3 ***}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Menus;

type
  TfrmV3 = class(TForm)
    mnuMain: TMainMenu;
    mnuOpsieA: TMenuItem;
    mnuOpsieB: TMenuItem;
    mnuVerlaat: TMenuItem;
    redV3: TRichEdit;
    mnuOpsieC: TMenuItem;
    procedure mnuVerlaatClick(Sender: TObject);
    procedure mnuOpsieAClick(Sender: TObject);
    procedure mnuOpsieBClick(Sender: TObject);
    procedure mnuOpsieCClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmV3: TfrmV3;

arrData : Array[1..40] of String = 
('Rachel Delarosa@Kanada#SH#11861','Corradino Grande@Spanje#RO#5788',
'Lucas Herder@Duitsland#NA#7709', 'Estotz Lizarazu@Frankryk#TU#12349',
'Chynna Taylor@Engeland#TU#8551','Renata Di@Spanje#RO#4906',
'Ugs Boulot-Tolle@Frankryk#KA#7300','Lena Bucholtz@Duitsland#TU#10344',
'Maria Heimpel@Duitsland#SH#9438', 'Julian Amstadter@Duitsland#RO#8840',
'Sofie Mosbauer@Duitsland#TU#5894', 'Fiona Green@Engeland#KA#9094',
'Sara Escobedo@Kanada#NA#4381', 'Nataly Mahan@Kanada#RO#12642',
'Wyatt Parham@Kanada#SH#4799','Noah Donovan@Kanada#SH#3888',
'Joseph Scott@Engeland#SH#7928', 'Emily Smith@Engeland#NA#3110',
'Adriana Mancuso@Spanje#RO#3724', 'Cassandra Wilder@Kanada#NA#12583',
'Tomasino Camporese@Spanje#NA#6777', 'Stacy Anderson@Engeland#RO#3686',
'Guiraud Bluteau@Frankryk#RO#11592','Damian Friedman@Kanada#RO#9012',
'Anne Loef@Duitsland#NA#13035', 'Terence Brown@Engeland#SH#8180',
'Lion Ghislieri@Spanje#RO#14343', 'Giraudetz Girardin@Frankryk#KA#11644',
'Guglielmo Capriati@Spanje#SH#5408', 'David Geiberger@Duitsland#RO#9854',
'Irisa Cooper@Engeland#NA#11456','Hayden Mcdonough@Kanada#NA#7840',
'Jonas Hipp@Duitsland#RO#3137', 'Emily Kohler@Duitsland#TU#6509',
'Emily Thul@Duitsland#RO#8551', 'Gino Lazzaretti@Spanje#KA#2329',
'Alex Hofstater@Duitsland#TU#6751', 'Peers Scott@Engeland#RO#9470',
'Liliana Horne@Kanada#RO#14689', 'Leon Kleinpaul@Duitsland#RO#15194');

implementation

VAR
  //array gebruik vir Opsie 3.
  arrBestem  : array[1..6] of string =
               ('Kaapse Wynland','Tuinroete','Nasionale Krugerwildtuin',
                'Robbeneiland (Engelse toer)', 'Robbeneiland (Ander toer)',
                'Shakaland');

{$R *.dfm}
{$R+}

procedure TfrmV3.mnuOpsieAClick(Sender: TObject);
var
   a               : Integer;
   rRand, rTotaal  : Real;
   sTemp           : String;
begin
  {Kode vir Opsie A}
  redV3.Lines.Clear;
  rTotaal := 0;
  for A := 1 to 40 do
   begin
      IF ((pos('Frankryk', arrData[a]) > 0) OR (pos('Duitsland', arrData[a]) > 0)
           OR (pos('Spanje', arrData[a]) > 0))
       then
        begin
          sTemp := arrData[a];
          Delete(sTemp, 1, pos('#', sTemp));
          Delete(sTemp, 1, pos('#', sTemp));
          rTotaal := rTotaal + StrToFloat(sTemp);
        end;
   end;
   rRand := rTotaal * 10.75;
   redV3.Lines.Add('Totale bedrag in euro: '+ FloatToStr(rTotaal));
   redV3.Lines.Add('Totale bedrag in Suid-Afrikaanse rand: ' +
                          FloatToStrF(rRand, ffCurrency, 8, 2));
end;

procedure TfrmV3.mnuOpsieBClick(Sender: TObject);
var
   a, Indeks               : Integer;
begin
  {Kode vir Opsie B}
  redV3.Lines.Clear;
  redV3.Lines.Add('Lys van Engelssprekende toeriste na Robbeneiland');
  redV3.Lines.Add('================================================');
  for a := 1 to 40 do
   begin
     if pos('#RO#', arrData[a]) > 0
      then
       begin
         Indeks := pos('#RO#', arrData[a]);
         IF (pos('Kanada', arrData[a]) > 0) OR
            (pos('Engeland', arrData[a]) > 0)
            then
             begin
                Delete(arrData[a], Indeks, 4);
                Insert('#ROEngels#', arrData[a], Indeks);
                //Insert('Engels', arrData[a], Indeks+4); //alternatief
                redV3.Lines.Add(Copy(arrData[a], 1, pos('@', arrData[a])-1));
             end //Kanada & Engeland .
            else
             begin
                Delete(arrData[a], Indeks, 4);
                Insert('#ROAnder#', arrData[a], Indeks);
                //Insert('Ander', arrData[a], Indeks+4); //alternatief
             end;
       end; //robbeneiland.
   end;
end;

procedure TfrmV3.mnuOpsieCClick(Sender: TObject);
var
  arrTel           : Array[1..6] of integer;
  a, b, iGrad      : integer;
  sBeste, sGrad     : string;
begin
  {Kode vir Opsie C}
  redV3.Lines.Clear;
  redV3.Paragraph.TabCount := 2;
  redV3.Paragraph.Tab[0]   := 150;
  redV3.Paragraph.Tab[1]   := 200;
  redV3.Lines.Add('Stergradering van toere');
  redV3.Lines.Add('======================================');
  redV3.Lines.Add('Bestemming' + #9 + 'Gradering' + #9 + 'Getal toeriste');
  redV3.Lines.Add('======================================');
  for a := 1 to 6 do
    arrTel[a] := 0;

  for a := 1 to 40 do
    begin
      sBeste := Uppercase(copy(arrData[a], pos('#',arrData[a])+1,3));
      case sBeste[1] of
        'K' : inc(arrTel[1],1); //Kaapse Wynland.
        'N' : inc(arrTel[3],1); //Nasionale Krugerwildtuin
        'T' : inc(arrTel[2],1); //Tuinroete.
        'R' : case sBeste[3] of  //Robbeneiland.
               'E' : inc(arrTel[4],1);     //Engels
               'A' : inc(arrTel[5],1);     //Ander
              end;
        'S' : inc(arrTel[6],1);        //Shakaland.
      end;
    end;//FOR 40
  For a := 1 to 6 do
    begin
      sGrad := '';
      iGrad := arrTel[a] div 3;
      for b := 1 to iGrad do
         sGrad := sGrad + '*';
      redV3.Lines.Add(arrBestem[a] + #9 + sGrad + #9 + '(' +
                                 IntToStr(arrTel[a]) + ')');
   end; //vertoon info
end;

procedure TfrmV3.mnuVerlaatClick(Sender: TObject);
begin
   Application.Terminate;
end;

end.
