import java.text.DecimalFormat;

/**
 *
 * Memo Vraag 2 - MAART 2013
 */
public class Vr2_MEMO {
    private String gNaam;
    private String bNaam;
    private String mNaam;
    private int aantD;
    private int aantT;
    private double tarief;

    public Vr2_MEMO(String gNaam, String bNaam, String mNaam, int aantD, int aantT) {
        this.gNaam = gNaam;
        this.bNaam = bNaam;
        this.mNaam = mNaam;
        this.aantD = aantD;
        this.aantT = aantT;
        setTarief();  
    }

  private void setTarief() 
    {
       String sNaam = mNaam.toUpperCase();
        //aanvaar oplossing wat nie toUpperCase() gebruik nie
        if (sNaam.equals("DESEMBER") || sNaam.equals("APRIL") || sNaam.equals("SEPTEMBER")) 
           tarief = 1250;
        else
          if (sNaam.equals("MEI") || sNaam.equals("MAART") || sNaam.equals("JUNIE") || sNaam.equals("JULIE")) 
		      tarief = 900;
          else
            tarief = 1000;       
    }

    private String verkortString()
    {
        String kortNaam = mNaam.substring(0,1);
        String klinkers = "AEIOU";
		  //aanvaar ook oplossing wat kleinlettes gebruik
        for (int tel = 1; tel < mNaam.length();tel++)
        {
            char letter = mNaam.charAt(tel);
            if(klinkers.indexOf(mNaam.toUpperCase().charAt(tel))<0)
            {
                kortNaam =kortNaam + letter;
            }
        }
        return  kortNaam;
    }

    public char vindGelukKarak()
    {
        int laaste = bNaam.length()-1;
        int eerste = 1;
        int posisie = 0;
        boolean herhaal = true;
        char karak = ' ';
        do
        {
            posisie = (int)(Math.random() * (laaste-eerste+1) + eerste);
            karak = bNaam.charAt(posisie);            
            if (karak != ' ')
            {
                herhaal = false;
                karak = bNaam.charAt(posisie);
            }
            
        }while (herhaal == true);
        return karak;
    }

    public String toString()
    {
        DecimalFormat df = new DecimalFormat("R 0.00");
        return "Maand: " + verkortString() + "\nBestemming: " + bNaam + " met " +  gNaam + " as die toergids\nPrys: " + df.format(getTarief())+ " per dag vir 'n tydperk van " + aantD + " dae\n"+ aantT+" toeriste gaan op hierdie toer.\n";
    }
 
    public String getGNaam() {
        return gNaam;
    }

    public void setGNaam(String gNaam) {
        this.gNaam = gNaam;
    }

    public String getBNaam() {
        return bNaam;
    }

    public void setBNaam(String bNaam) {
        this.bNaam = bNaam;
    }

    public String getMNaam() {
        return mNaam;
    }

    public int getAantD() {
        return aantD;
    }

    public void setAantD(int aantD) {
        this.aantD = aantD;
    }

    public int getAantT() {
        return aantT;
    }

    public void setAantT(int aantT) {
        this.aantT = aantT;
    }

    public double getTarief() {
        return tarief;
    }
}
