   import java.io.BufferedReader;
   import java.io.InputStreamReader;

/**
 Oplossing Vraag 3
 */
    public class Vraag3_MEMO {
   
String[] arrData = {"Rachel Delarosa@Kanada#SH#11861","Corradino Grande@Spanje#RO#5788",
"Lucas Herder@Duitsland#NA#7709", "Estotz Lizarazu@Frankryk#TU#12349",
"Chynna Taylor@Engeland#TU#8551","Renata Di@Spanje#RO#4906",
"Ugs Boulot-Tolle@Frankryk#KA#7300","Lena Bucholtz@Duitsland#TU#10344",
"Maria Heimpel@Duitsland#SH#9438", "Julian Amstadter@Duitsland#RO#8840",
"Sofie Mosbauer@Duitsland#TU#5894", "Fiona Green@Engeland#KA#9094",
"Sara Escobedo@Kanada#NA#4381", "Nataly Mahan@Kanada#RO#12642",
"Wyatt Parham@Kanada#SH#4799","Noah Donovan@Kanada#SH#3888",
"Joseph Scott@Engeland#SH#7928", "Emily Smith@Engeland#NA#3110",
"Adriana Mancuso@Spanje#RO#3724", "Cassandra Wilder@Kanada#NA#12583",
"Tomasino Camporese@Spanje#NA#6777", "Stacy Anderson@Engeland#RO#3686",
"Guiraud Bluteau@Frankryk#RO#11592","Damian Friedman@Kanada#RO#9012",
"Anne Loef@Duitsland#NA#13035", "Terence Brown@Engeland#SH#8180",
"Lion Ghislieri@Spanje#RO#14343", "Giraudetz Girardin@Frankryk#KA#11644",
"Guglielmo Capriati@Spanje#SH#5408", "David Geiberger@Duitsland#RO#9854",
"Irisa Cooper@Engeland#NA#11456","Hayden Mcdonough@Kanada#NA#7840",
"Jonas Hipp@Duitsland#RO#3137", "Emily Kohler@Duitsland#TU#6509",
"Emily Thul@Duitsland#RO#8551", "Gino Lazzaretti@Spanje#KA#2329",
"Alex Hofstater@Duitsland#TU#6751", "Peers Scott@Engeland#RO#9470",
"Liliana Horne@Kanada#RO#14689", "Leon Kleinpaul@Duitsland#RO#15194"};    

		String []skikBestemmings = {"Kaapse Wynland","Tuinroete", "Nasionale Krugerwildtuin", 
         "Robbeneiland (Engelse toer)","Robbeneiland (Ander toer)", "Shakaland"};
   	
      BufferedReader kb;
   //=====================================================================================
       public void keuselys() throws Exception {
        
         kb = new BufferedReader(new InputStreamReader(System.in));
         char keuse =' ';
         do {
            System.out.println("KEUSELYS");
            System.out.println();
            System.out.println("   Opsie A");
            System.out.println("   Opsie B");
            System.out.println("   Opsie C");
            System.out.println();
            System.out.println("V - VERLAAT");
            System.out.println();
            System.out.println("Jou keuse?");
            keuse = kb.readLine().toUpperCase().charAt(0);
            switch (keuse) {
               case 'A': eurosOmskakel();     						
                  break;
               case 'B': verdeelGroep();
                  break;
               case 'C': bepaalGewildheid();
                  break;
               case 'V':
                  System.out.println("VERLAAT");
            }
         } while (keuse != 'V');
      }
   //========================================================================================
   //Opsie A	
       public void eurosOmskakel()
      {      
         double waarde = 0;
         for (int c = 0; c < arrData.length; c++) 
         {
            Toeris toeris = new Toeris(arrData[c]);
            String land = toeris.getLand();
            if (land.equalsIgnoreCase("Frankryk") ||land.equalsIgnoreCase("Spanje")||land.equalsIgnoreCase("Duitsland")) 
            { 	
               waarde = waarde + toeris.getGeld();
            }
         }   
         System.out.printf("%s%-8.0f\n","Totale bedrag in euro: ", waarde);
         double rand = waarde*10.75;
         System.out.printf("%sR%10.2f\n\n","Totale bedrag in Suid-Afrikaanse rand: ", rand); 
      }
   	//=========================================================================================
     // Opsie B
       public void verdeelGroep()
      {				       						
          System.out.println("Lys van Engelssprekende toeriste na Robbeneiland");
         System.out.println("================================================");
         for (int c = 0; c < arrData.length; c++) 
         {
            Toeris toeris = new Toeris(arrData[c]);
            String dest = toeris.getBestemming();
         			  
            if (dest.equals("RO")) 
            {
               String land = toeris.getLand();											
               if (land.equalsIgnoreCase("Engeland") || land.equalsIgnoreCase("Kanada"))
               {
                  System.out.println(toeris.getNaam());							
                  arrData[c] = arrData[c].replace("#RO#","#ROEngels#");
                  toeris.setBestemming("ROEngels");										
               }
               else
               {
                  arrData[c] = arrData[c].replace("#RO#","#ROAnder#");
                  toeris.setBestemming("ROAnder");		
               } // else
            } // if
         }// for		
      
         System.out.println("\n\n"); 
      }
   			
   //======================================================================================
   // Opsie C
       public void bepaalGewildheid()
      {
         int[] skikTeller = new int[6];
         System.out.println("Stergradering van toere");
         System.out.println("===============================================================");
         System.out.println("Bestemming                         Gradering  Getal toeriste");
         System.out.println("===============================================================");
			for (int c = 0; c < 6; c++)
			{
			 skikTeller[c]=0;
			}               
         for (int c = 0; c < arrData.length; c++) 
         {
            Toeris toeris = new Toeris(arrData[c]);
            String bestemKode = toeris.getBestemming();
				
				switch (bestemKode.toUpperCase().charAt(0))
				{
				case 'K' : skikTeller[0]++; break;
				case 'N' : skikTeller[2]++; break;
				case 'T' : skikTeller[1]++; break;
				case 'R' : if (bestemKode.toUpperCase().charAt(2) == 'E')
									skikTeller[3]++;
							  else skikTeller[4]++;break;
				case 'S' : skikTeller[5]++;break;				
				}
         }// for
      // output
         for (int i = 0; i < 6; i++)
         {
            String sterString = "";
            int aantSterre = skikTeller[i]/3;
            for (int s = 0; s < aantSterre; s++)
            {
               sterString = sterString + "*";
            }
            String afvString = String.format("%-35s%-10s(%d)",skikBestemmings[i],sterString,skikTeller[i]);
            System.out.println(afvString);                        
         }
      				
         System.out.println("\n\n");
      }
   
   }
